.base_job:
  stage: build_base
  image: docker:latest
  services:
    - docker:dind
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - apk update && apk add python3 py3-pip
    - pip3 install -r generator/requirements.txt
    - TAG=$(head -n 1 version.txt)
    - echo "VERSION -> $TAG"
    - if [[ $CI_COMMIT_REF_NAME == "master" ]]; then
         IMAGE_NAME="${CI_REGISTRY_IMAGE}/alpaka-ci-${NAME_PREFIX}";
      else
         IMAGE_NAME="${CI_REGISTRY_IMAGE}/alpaka-ci-${NAME_PREFIX}-$(echo ${CI_COMMIT_BRANCH} | awk '{print tolower($0)}')";
      fi
    - echo "IMAGE_NAME -> $IMAGE_NAME"
  script:
    - python3 generator/recipe.py $ARGS --version $TAG > Dockerfile
    - docker build -t "$IMAGE_NAME:$TAG" .
    - docker push "$IMAGE_NAME:$TAG"
    - if [[ $CI_COMMIT_REF_NAME == "master" ]]; then
        docker tag "$IMAGE_NAME:$TAG" "$IMAGE_NAME:latest";
        docker push "$IMAGE_NAME:latest";
      fi

.cuda_job:
  stage: build_base
  image: docker:latest
  extends:
    .base_job
  script:
    - python3 generator/recipe.py $ARGS --version $TAG > Dockerfile
    - docker build -t "$IMAGE_NAME:$TAG" .
    - docker push "$IMAGE_NAME:$TAG"
    - if [[ $CI_COMMIT_REF_NAME == "master" ]]; then
        docker tag "$IMAGE_NAME:$TAG" "$IMAGE_NAME:latest";
        docker push "$IMAGE_NAME:latest";
      fi
    - python3 generator/recipe.py $ARGS --clang --version $TAG > Dockerfile
    - docker build -t "$IMAGE_NAME-clang:${TAG}" .
    - docker push "$IMAGE_NAME-clang:$TAG"
    - if [[ $CI_COMMIT_REF_NAME == "master" ]]; then
        docker tag "$IMAGE_NAME-clang:$TAG" "$IMAGE_NAME-clang:latest";
        docker push "$IMAGE_NAME-clang:latest";
      fi
    - python3 generator/recipe.py $ARGS --gcc --version $TAG > Dockerfile
    - docker build -t "$IMAGE_NAME-gcc:${TAG}" .
    - docker push "$IMAGE_NAME-gcc:$TAG"
    - if [[ $CI_COMMIT_REF_NAME == "master" ]]; then
        docker tag "$IMAGE_NAME-gcc:$TAG" "$IMAGE_NAME-gcc:latest";
        docker push "$IMAGE_NAME-gcc:latest";
      fi

.base_picongpu_job:
  stage: build_picongpu
  image: docker:latest
  services:
    - docker:dind
  variables:
    REG_SHA256: ade837fc5224acd8c34732bf54a94f579b47851cc6a7fd5899a98386b782e228
    REG_VERSION: 0.16.1
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - apk update && apk add python3 py3-pip
    - pip3 install -r generator/requirements.txt
    - TAG=$(head -n 1 version.txt)
    - echo "VERSION -> $TAG"
    - if [[ $CI_COMMIT_REF_NAME == "master" ]]; then
         IMAGE_NAME="${CI_REGISTRY_IMAGE}/alpaka-ci-${NAME_PREFIX}";
      else
         IMAGE_NAME="${CI_REGISTRY_IMAGE}/alpaka-ci-${NAME_PREFIX}-$(echo ${CI_COMMIT_BRANCH} | awk '{print tolower($0)}')";
      fi
    - echo "IMAGE_NAME -> $IMAGE_NAME"
  script:
    - python3 generator/ci_picongpu.py "$IMAGE_NAME:$TAG" > Dockerfile
    - docker build -t "$IMAGE_NAME-pic:${TAG}" .
    - if [[ $CI_COMMIT_REF_NAME == "master" ]]; then
        docker push "$IMAGE_NAME-pic:$TAG";
        docker tag "$IMAGE_NAME-pic:$TAG" "$IMAGE_NAME-pic:latest";
        docker push "$IMAGE_NAME-pic:latest";
      fi
  after_script:
    - TAG=$(head -n 1 version.txt)
    - if [[ $CI_COMMIT_REF_NAME == "master" ]]; then
         IMAGE_NAME="${CI_REGISTRY_IMAGE}/alpaka-ci-${NAME_PREFIX}";
      else
         IMAGE_NAME="${CI_REGISTRY_IMAGE}/alpaka-ci-${NAME_PREFIX}-$(echo ${CI_COMMIT_BRANCH} | awk '{print tolower($0)}')";
      fi
    - if [[ $CI_COMMIT_REF_NAME != "master" ]]; then
        echo "clean up registry";
        apk add --no-cache curl;
        curl --fail --show-error --location "https://github.com/genuinetools/reg/releases/download/v$REG_VERSION/reg-linux-amd64" --output /usr/local/bin/reg;
        echo "$REG_SHA256  /usr/local/bin/reg" | sha256sum -c -;
        chmod a+x /usr/local/bin/reg;
        chmod a+x ./scripts/delete_image.sh;
        ./scripts/delete_image.sh ${IMAGE_NAME} ${TAG};
      fi

.cuda_picongpu_job:
  stage: build_picongpu
  image: docker:latest
  variables:
    REG_SHA256: ade837fc5224acd8c34732bf54a94f579b47851cc6a7fd5899a98386b782e228
    REG_VERSION: 0.16.1
  extends:
    .base_job
  script:
    - python3 generator/ci_picongpu.py "$IMAGE_NAME:$TAG" > Dockerfile
    - docker build -t "$IMAGE_NAME-pic:${TAG}" .
    - if [[ $CI_COMMIT_REF_NAME == "master" ]]; then
        docker push "$IMAGE_NAME-pic:$TAG";
        docker tag "$IMAGE_NAME-pic:$TAG" "$IMAGE_NAME-pic:latest";
        docker push "$IMAGE_NAME-pic:latest";
      fi
    - python3 generator/ci_picongpu.py "$IMAGE_NAME-clang:$TAG" > Dockerfile
    - docker build -t "$IMAGE_NAME-clangpic:$TAG" .
    - if [[ $CI_COMMIT_REF_NAME == "master" ]]; then
        docker push "$IMAGE_NAME-clangpic:$TAG";
        docker tag "$IMAGE_NAME-clangpic:$TAG" "$IMAGE_NAME-clangpic:latest";
        docker push "$IMAGE_NAME-clangpic:latest";
      fi
    - python3 generator/ci_picongpu.py "$IMAGE_NAME-gcc:$TAG" > Dockerfile
    - docker build -t "$IMAGE_NAME-gccpic:$TAG" .
    - if [[ $CI_COMMIT_REF_NAME == "master" ]]; then
        docker push "$IMAGE_NAME-gccpic:$TAG";
        docker tag "$IMAGE_NAME-gccpic:$TAG" "$IMAGE_NAME-gccpic:latest";
        docker push "$IMAGE_NAME-gccpic:latest";
      fi
  after_script:
    - TAG=$(head -n 1 version.txt)
    - if [[ $CI_COMMIT_REF_NAME == "master" ]]; then
         IMAGE_NAME="${CI_REGISTRY_IMAGE}/alpaka-ci-${NAME_PREFIX}";
      else
         IMAGE_NAME="${CI_REGISTRY_IMAGE}/alpaka-ci-${NAME_PREFIX}-$(echo ${CI_COMMIT_BRANCH} | awk '{print tolower($0)}')";
      fi
    - if [[ $CI_COMMIT_REF_NAME != "master" ]]; then
        echo "clean up registry";
        apk add --no-cache curl;
        curl --fail --show-error --location "https://github.com/genuinetools/reg/releases/download/v$REG_VERSION/reg-linux-amd64" --output /usr/local/bin/reg;
        echo "$REG_SHA256  /usr/local/bin/reg" | sha256sum -c -;
        chmod a+x /usr/local/bin/reg;
        chmod a+x ./scripts/delete_image.sh;
        ./scripts/delete_image.sh ${IMAGE_NAME} ${TAG};
        ./scripts/delete_image.sh "${IMAGE_NAME}-clang" ${TAG};
        ./scripts/delete_image.sh "${IMAGE_NAME}-gcc" ${TAG};
      fi

